1	{$S 40}				(* 40 kB Speicher reservieren *)
2	{$P -}					(* Bereichsprfung fr Zeiger aus *)
3
4	program TXTPRINT;
5
6	const
7
8	Vorderseite = 0;
9	Rueckseite = 1;
10
11	type
12
13	Seiten_Typ = Vorderseite .. Rueckseite;
14
15	Namens_Typ = packed array [1..80] of char;
16
17	DTA_Typ    = packed record
18
19		res      : packed array [0..19] of byte;
20		res1     : byte;
21		Attribut : byte;
22		Zeit     : integer;
23		Datum    : integer;
24		Laenge   : long_integer;
25		Name     : packed array [1..14] of char;
26
27	end;					(* record *)
28
29	DTA_Zeiger    = ^DTA_Typ;
30
31	Zeilen_Typ    = packed array [1..500] of char;
32	Zeile         = ^Zeilen_Typ;
33	Zeilen_Array  = array [1..30000] of Zeile;
34	Zeilen_Zeiger = ^Zeilen_Array;
35
36	Seiten_Array  = array [1..2000] of integer;
37	Seiten_Zeiger = ^Seiten_Array;
38
39	Transfer_Typ  = record
40		case byte of
41			1: (Linie : Zeile);
42			2: (Feld  : Zeilen_Zeiger);
43			3: (long  : long_integer);
44	end;
45
46	Filter_Typ   = array [1..255] of byte;
47
48	Schrift_Typ = array [1..10] of
49	record
50		Anzahl_Steuercodes : integer;
51		Codes              : packed array [1..30] of char;
52	end;
53	Schrift_Zeiger = ^Schrift_Type;
54
55	var
56		Zeilen_pro_Seite, Zeichen_pro_Zeile : integer;
57		Anzahl_Seiten, Anzahl_Zeilen        : integer;
58		Laengste_Zeile, Schriftnummer       : integer;
59		Drucker, Nummerndruck, Wechsel      : boolean;
60		Laenge     : long_integer;
61		Zeilen     : Zeilen_Zeiger;
62		Seiten     : Seiten_Zeiger;
63		Dateinamen : Namens_Typ;
64		Filter     : Filter_typ;
65
66
67	(* Systemroutinen *)
68
69	function FOpen (var Name : Namens_Typ; Mode : integer): integer;
70		GEMDOS ($3D);
71
72	procedur FClose (Handle : integer);
73		GEMDOS ($3E);
74
75	function FRead (Handle : integer; Anzahl : long_integer;
76	                Wohin : long_integer) : long_integer;
77		GEMDOS ($3F);
78
79	function FGetDTA : DTA_Zeiger;
80		GEMDOS ($2F);
81
82	function FSFirst (var : Name : Namens_Typ; Attribut : integer): integer;
83		GEMDOS ($4E);
84
85	function Malloc (groesse : long_integer): long_integer;
86		GEMDOS ($48);
87
88	function Mfree (adresse : long_integer) : integer;
89		GEMDOS ($49);
90
91	(* Vereinbarung der Assembler-Routinen als External *)
92
93	procedure InitMem (Laenge            : long_integer;
94	                   Zeichen_pro_Zeile : integer;
95	                   Zeilen_Array      : Zeilen_Zeiger;
96	                   var Anzahl_Zeilen : integer;
97	                   Zeilen_pro_Seite  : integer;
98	                   Seitenliste       : Seiten_Zeiger;
99	                   var Anzahl_Seiten : integer );
100
101	External;
102
103	function Zeilenlaenge (Zeilennummer : integer;
104	                       Zeilen_Array: Zeilen_Zeiger) : integer;
105	External;
106
107	procedure PreCheck (Textanfang : Zeile; Laenge : long_integer;
108	                    var Anzahl_Zeilen, Laengste_Zeile : integer);
109
110	External;
111
112	function GetPrinter : Schrift_Zeiger;
113	External;
114
115	(* Hilfsroutinen *)
116
117
118	procedure Str_C (s : string; var c : Namens_Typ);
119
120	(* Umwandlung von Pascal-Strings in C-Zeichenketten fr GEMDOS *)
121
122	var  i : integer;
123
124	begin
125
126		for i := 1 to length (s) do c[i] := s[i];
127		c[i+1] := chr (0);
128
129	end;					(* Str_C *)
130
131
132	procedure Filter_Initialisierung (var Filter : Filter_Typ);
133
134	var  i : integer;
135
136	begin
137
138		for i := 1 to 255 do
139			Filter[i] := i;
140
141		(* Hier eigene Umleitungen einfgen *)
142		Filter[$9E] := $E1;	(*  im ST-Zeichensatz auf Drucker- umleiten *)
143
144	end;					(* Filter_Initialisierung *)
145
146
147	procedure SetPrinter (Schriftnummer : integer);
148
149	(* Schickt die ausgewhlte Steuersequenz an den Drucker *)
150
151	var Schrift : Schrift_Zeiger;
152	    i       : integer;
153
154	begin
155
156		Schrift := GetPrinter;
157		rewrite ( output, LST:);
158		for i := 1 to Schrift^[Schriftnummer].Anzahl_Steuercodes do
159			write (Schrift^[Schriftnummer].Codes[i]);
160		rewrite (output, CON:);
161
162	end;					(* SetPrinter *)
163
164	(* Hauptroutinen *)
165
166	procedure Datei_Auswahl (var Name : Names_Typ);
167
168	var Str : string;
169
170	begin
171
172		write (Dateiname: );
173		readln (Str);
174		Str_C (Str, Name);
175
176	end;					(* Datei_Auswahl *)
177
178
179	procedure Parameter_Eingabe (var Zeilen_pro_Seite, Schriftnummer,
180	                             Zeichen_pro_Zeile                  : integer;
181	                             var Drucker, Nummerndruck, Wechsel : boolean;
182	                             Laenge                             : long_integer;
183	                             Anzahl_Zeilen, Laengste_Zeile      : integer );
184
185	var c : char;
186
187	begin
188
189		Writeln (Dateilnge               : , Laenge);
190		writeln (Anzahl Zeilen            : , Anzahl_Zeilen);
191		writeln (Lnge der Lngsten Zeile : , Laengste_Zeile);
192		writeln;
193		writeln (*** Parametereingabe ***);
194		write (Maximale Anzahl Zeilen pro Seite  : );
195		readln (Zeilen_pro_Seite);
196		write (Maximale Anzahl Zeichen pro zeile : );
197		readln (Zeichen_proZeile);
198		write (Ausgabe auf Drucker (J/N)         : );
199		read (c);
200		writeln;
201		Drucker := c in [j, J];
202		if Drucker
203		then begin
204			write (Schriftnummer: );
205			readln (Schriftnummer);
206		end;
207		write (Zeilennummerndruck  (J/N)         : );
208		read (c);
209		writeln;
210		Nummerndruck := c in [j, J];
211		write (Beidseitiger Druck (J/N)          : );
212		read (c);
213		writeln;
214		Wechsel := c in [j, J];
215
216	end;					(* Parametereingabe *)
217
218
219	function Datei_Laden (Datei : Namens_Typ; var Zeilen_Array : Zeilen_Zeiger;
220	                      var Laenge : long_integer) : boolean;
221
222	var	DTA      : DTA_Zeiger;
223		Transfer : Transfer_Typ;
224		Ok       : boolean;
225		Handle   : integer;
226		Anzahl   : long_integer;
227
228	begin
229
230		Ok := false;
231		DTA := FGetDTA;
232
233		if FSFirst (datei, 0) = 0	(* Datei vorhanden? *)
234		then
235		begin
236			Laenge        := DTA^.Laenge;
237			Transfer.Long := Malloc (laenge);
238			if (Transfer.Long mod 2) <> 0
239			then begin writeln (Ungerade Adresse bei Zeilenfeld!);
240				readln;
241			end;
242			if Transfer.Long > 0	(* Genug Speicher vorhanden fr Zeilenfeld? *)
243			then
244			begin
245				Zeilen_Array  := Transfer.Feld;
246				Transfer.Long := Malloc (Laenge);
247				if (Transfer.Long mod 2) <> 0
248				then begin writeln (Ungerade Adresse bei Zeichenfeld!);
249					readln;
250				end;
251				if Transfer.Long > 0	(* Genug Speicher vorhanden fr Zeichenfeld? *)
252				then
253				begin
254					Zeilen_Array^[1] := Transfer.Line;
255					Handle := FOpen (Datei, 0);
256					if handle > 0
257					then
258					begin				(* File lesen *);
259						Anzahl := FRead (Handle, Laenge, Transfer.Long);
260						if Anzahl = Laenge
261						then Ok := true;
262							FClose (Handle);
263						end
264					end
265				else
266				begin
267					Transfer.Feld := Zeilen_Array;
268					Anzahl := MFree (Transfer.Long);
269				end
270			end
271		end;
272
273		Datei_Laden := Ok;
274	
275	end;
276
277
278	procedure Speicher_Freigeben (var Zeilen_Array : Zeilen_Zeiger);
279
280	var	Transfer : Transfer_Typ;
281		ret      : integer;
282
283	begin
284
285		Transfer.Line := Zeilen_Array^[1];
286		ret           := MFree (Transfer.Long);
287		Transfer.Feld := Zeilen_Array;
288		ret           := MFree (Transfer.Long);
289
290	end;								(* Speicher_Freigeben *)
291
292
293	procedure Ausdruck (Zeilen : Zeilen_Zeiger; Anzahl_Seiten : integer
294	                    Drucker, Nummerndruck, Wechsel : boolean);
295
296	var	lauf1  : integer;
297		Seite  : Seiten_Typ;
298
299	procedure Drucke_Zeile (Nummer, Seitennummer : integer);
300
301	var	lauf2 : integer;
302
303	begin
304
305		if Nummerndruck
306		then if Seitenummer = 0
307		then write (Nummer : 5,  );
308		else write (S, Seitennummer : 4, : );
309		for lauf2 := 1 to Zeilenlaenge (Nummer, Zeilen)
310			do if Drucker
311				then write (chr (Filter[ord (Zeilen^[Nummer]^[lauf2])]));
312				else write (Zeilen^[Nummer]^[lauf2]);
313			writeln;
314
315	end;								(* Drucke_Zeile *)
316
317	procedure Drucke_Seite (Nummer : integer);
318
319	var	lauf3 : integer;
320
321	begin
322
323		Drucke_Zeile (Seiten^[Nummer], Nummer);
324		for lauf3 := (Seiten^[Nummer] +1) to (Seiten^[Nummer] -1)
325			do Drucke_Zeile (lauf3, 0);
326
327		if Drucker
328			then write (chr (12));
329		else begin
330			write (*************** Seitenende! ***************);
331			readln;
332		end;
333
334	end;								(* Drucke_Seite *)
335
336	begin								(* Ausdruck *)
337
338		if Drucker
339			then rewrite (output, LST:);
340
341		if Wechsel
342		then
343
344			for Seite := Vorderseite to Rueckseite do
345			begin
346				lauf1 := 1
347				while lauf1 + ord (Seite) <= Anzahl_Seiten do
348				begin
349					Drucke_Seite (lauf1 + ord (Seite);
350					lauf1 := lauf1 + 2;
351				end;
352				if (Seite = Vorderseite) and Drucker and (Anzahl_Seiten > 1)
353				then begin
354					write (chr (7));
355					rewrite (output, CON:);
356
357					writeln (Papierwechsel fr gerade Seiten durchfhren!);
358					writeln (Nach vollzogenem Wechsel [Return] drcken!);
359					readln;
360					rewrite (output, LST:);
361				end;
362			end;
363
364		else
365			for lauf := 1 to Anzahl_Seiten do
366				Drucke_Seite (lauf1);
367
368		if Drucker
369			then rewrite (output, CON:);
370
371	end;								(* Ausdruck *)
372
373
374	begin								(* Hauptprogramm *)
375
376		Datei_Auswahl (Dateiname);
379
380		if Datei_Laden (Dateiname, Zeilen, Laenge)
381		then
382		begin
383
384			PreCheck (Zeilen^[1], Laenge, Anzahl_Zeilen, Laengste_Zeile);
385
386			Parameter_Eingabe (Zeilen_pro_Seite, Schriftnummer, Zeichen_pro_Zeile,
387			                   Drucker, Nummerndruck, Wechsel, Laenge,
388			                   Anzahl_Zeilen, Laengste_Zeile);
389
390			if Nummerndruck
391			then Zeichen_pro_Zeile := Zeichen_pro_Zeile - 7;
392
393			InitMem (Laenge, Zeichen_pro_Zeile, Zeilen, Anzahl_Zeilen,
394			         Zeilen_pro_Seite, Seiten, Anzahl_Seiten);
395
396			writeln (Anzahl Zeilen: , Anzahl_Zeilen);
397			writeln (Anzahl Seiten: , Anzahl_Seiten);
398
399			if Drucker
400			then begin
401				Filter_Initialisierung (Filter);
402				if Schriftnummer > 0
403					then SetPrinter (Schriftnummer);
404			end;
405
406			Ausdruck (Zeilen, Anzahl_Seiten, Drucker, Nummerndruck, Wechsel);
407
408			Speicher_Freigeben (Zeilen);
409
410		end;
411		else begin
412			writeln (Konnte datei nicht Laden!);
413			readln;
414		end;
415
416	end.